import gameInterface.AIInterface;
import structs.FrameData;
import structs.GameData;
import structs.Key;

import commandcenter.CommandCenter;

/**
 * @author Phakhawat Sarakit Fight Game AI Competition T No.23 Ver.6.4
 * 
 *27/8/2013
 * 
 */
public class T implements AIInterface {
	// my note skills.
	// cc.commandCall("8 2 1 4 _ B");//long jump punch
	// cc.commandCall("2 1 4 _ B");STAND_D_DB_BB//slide
	// cc.commandCall("2 1 4 _ A");STAND_D_DB_BA//jump sork
	// cc.commandCall("6 2 3 _ B");STAND_F_D_DFB//jump knee
	// cc.commandCall("6 2 3 _ A");STAND_F_D_DFA// upper cut
	// cc.commandCall("6 2 3 _ A");//jump puch
	// 2 3 6_A fireball STAND_D_DF_FA
	// 2 3 6_B fireball up STAND_D_DF_FB
	// 2 3 6 _ C super fireball STAND_D_DF_FC
	// cc.commandCall("9 6 _ B");AIR_D_DF_FA//jump kick
	// cc.commandCall("9 2 3 6 _ B");//jump puch

	Key inputKey;
	boolean playerNumber;
	FrameData frameData;
	CommandCenter cc;
	
	 

	@Override
	public int initialize(GameData gameData, boolean playerNumber) {

		this.playerNumber = playerNumber;
		this.inputKey = new Key();
		cc = new CommandCenter();
		frameData = new FrameData();
		
	
		return 0;
		
	}

	@Override
	public void getInformation(FrameData frameData) {
		this.frameData = frameData;

		cc.setFrameData(this.frameData, playerNumber);

	}

	@Override
	public void processing() {
		if (!frameData.emptyFlag && frameData.getRemainingTime() > 0) {
			System.out.println("x "+cc.getDistanceX());
			if (cc.getskillFlag()) {

				inputKey = cc.getSkillKey();
			} else {
				inputKey.empty();
				cc.skillCancel();
				// close combat
				if (!cc.getEnemyCharacter().getState().name().equals("AIR")
						&& cc.getDistanceX() <= 130) {
					cc.commandCall("4 _ B");// trow
				}
				//combo with thow
				else if (cc.getEnemyCharacter().getAction().name()
						.equals("THROW_SUFFER")) {
					cc.commandCall("6 2 3 _ A");// upper cut
				}
				// couter jump
				else if (cc.getEnemyCharacter().getAction().name().startsWith("AIR")
						&& cc.getDistanceX() < 150) {
					cc.commandCall("6 2 3 _ A");// upper cut
				}
				//attack			
				else if (!cc.getEnemyCharacter().getState().name()
						.equals("DOWN")
						&& cc.getDistanceX() > 130) {
						cc.commandCall("2 1 4 _ B");// slide
				}
				// couter jump
				else if (cc.getEnemyCharacter().getAction().name().startsWith("AIR")
						&& cc.getDistanceX() < 300) {
					cc.commandCall("6 2 3 _ B");// jump knee
				}
				
				// couter fireball
				else if (cc.getEnemyCharacter().getAction().name()
						.startsWith("STAND_D_DF_")&&!cc.getMyCharacter().getState().name().equals("DOWN")) {
					cc.commandCall("2 1 4 _ B");// slide
				}
								
				
				// shoot super fireball
				else if (!cc.getEnemyCharacter().getState().name().equals("AIR")
						&&!cc.getEnemyCharacter().getState().name().equals("DOWN")&& cc.getMyEnergy() > 300) {
					cc.commandCall("2 3 6 _ C");
				}
				//attack when enemy down
				else if (cc.getEnemyCharacter().getState().name()
						.equals("DOWN")&&cc.getDistanceX()>130&&cc.getDistanceX()<220) {
					cc.commandCall("2 3 6 _ B");
					
				}
				//step back for shoot fireball
				else if (cc.getEnemyCharacter().getAction().name()
						.equals("DOWN")&&cc.getDistanceX()>220&&cc.getDistanceX()<300&&cc.getMyEnergy()>300) {
					cc.commandCall("4");
				}
				//attack when enemy down
				else if (cc.getEnemyCharacter().getAction().name()
						.equals("DOWN")&&cc.getDistanceX()>220&&cc.getDistanceX()<300&&cc.getMyEnergy()<300) {
					
						try {
							Thread.sleep(20);
							cc.commandCall("2 1 4 _ A");
						} catch (InterruptedException e) {
							// TODO Auto-generated catch block
							e.printStackTrace();
						}
						
					
					
				}
				//attack when enemy down
				else if (cc.getEnemyCharacter().getState().name()
						.equals("DOWN")&&cc.getDistanceX()>300&&cc.getMyEnergy()>300) {
				try {
					Thread.sleep(18);
					cc.commandCall("2 3 6 _ C");
				} catch (InterruptedException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
					
			
					
				}
				//if enemy too far walk to enemy
				else if(cc.getDistanceX()>550){
					cc.commandCall("DASH");
				}
				
				else if(cc.getMyCharacter().getAction().name().equals("THROW_SUFFER")){
					cc.commandCall("BACK_STEP");
				
				}
				//couter slide attack
				else if(cc.getEnemyCharacter().getAction().name().equals("STAND_D_DB_BB")){
					cc.commandCall("AIR_D_DB_BB");
				}

			}
		}
	}

	@Override
	public Key input() {
		// TODO Auto-generated method stub
		return inputKey;
	}

	@Override
	public void close() {
		// TODO Auto-generated method stub
		
	}
	


}
